package RoutingMatrix;
import com.cycling74.max.*;
public class ScalingMath {

	
	float add =0;
	float mult=0;
	float inMin,outMin,inMax,outMax;
	float amount = 1;
	int mode = 0;
	public static final int NORMAL=0,FLIP=1,TAKEAWAY=2;
	
	public ScalingMath(float inMin,float inMax,float outMin,float outMax)
	{
	
		this.inMin=inMin;
		this.inMax=inMax;
		this.outMin=outMin;
		this.outMax=outMax;
		
		
		
		calcMultAdd();
	}
	
	public void setMode(int mode)
	{
		this.mode = Math.min(3, Math.max(0, mode));
		calcMultAdd();
		
	}
	
	public void setAmount (float amt){
		this.amount =amt;
		calcMultAdd();
	}
	
	private void calcMultAdd()
	{
		
		MaxObject.post("calcMultAdd()   in:" +inMin+"/"+inMax+"    out"+outMin+"/"+outMax+"    amount/mode"+amount+"/"+mode);
		float tempOutMax = interp(outMin,outMax,amount);
		float tempOutMin = outMin;
		MaxObject.post("A  tempOutMax"+tempOutMax+"    outMin"+outMin+"      outMin-tempOutMax="+(outMin-tempOutMax));
		
		
		
		
		float swapTemp ;
		switch(mode){
		case FLIP:
			
			swapTemp = tempOutMax;
			tempOutMax = tempOutMin;
			tempOutMin = swapTemp;
			
			break;
		case TAKEAWAY:
			tempOutMax = tempOutMin-tempOutMax;
			tempOutMin = 0;
			break;
		}
		
		MaxObject.post("B  tempOutMax"+tempOutMax+"    tempOutMin"+tempOutMin);
		
		float inSpan = inMax-inMin;
		float outSpan = tempOutMax-tempOutMin;
		
		
		
		mult = outSpan/inSpan;
		add = tempOutMin-(inMin*mult);	
		
	}
	
	public float interp(float a, float b, float interp)
	{
		return  ((b - a)* interp) + a;
	}
	
	
	public float getAdd()
	{
		return add;
		
	}
	
	public float getMult()
	{
		return mult;
	}
	
	public static float addFromScalers(float inMin,float inMax,float outMin,float outMax)
	{
		return new ScalingMath(inMin,inMax,outMin,outMax).getAdd();
	}
	
	public static float multFromScalers(float inMin,float inMax,float outMin,float outMax)
	{
		return new ScalingMath(inMin,inMax,outMin,outMax).getMult();
	}


	public void setInMin(float inMin) {
		this.inMin = inMin;
		calcMultAdd();
	}


	public void setOutMin(float outMin) {
		this.outMin = outMin;
		calcMultAdd();
	}


	public void setInMax(float inMax) {
		this.inMax = inMax;
		calcMultAdd();
	}


	public void setOutMax(float outMax) {
		this.outMax = outMax;
		calcMultAdd();
	}
	
	
	
}
